using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Inscritti_Amministratore_Ruoli : System.Web.UI.Page
{
    protected void Page_PreLoad(object sender, EventArgs e)
    {
        if (ListBoxUtentiNon.SelectedItem != null)
            Roles.AddUserToRole(ListBoxUtentiNon.SelectedValue, ListBoxRuoli.SelectedValue);
        if (ListBoxUtenti.SelectedItem != null)
            Roles.RemoveUserFromRole(ListBoxUtenti.SelectedValue, ListBoxRuoli.SelectedValue);
    }
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
            PopolamentoListeRuoli();     // popolamento liste ruoli
        PopolamentoListeUtenti(); // popolamento lista utenti in ruolo
    }
    protected void ButtonAddRuolo_Click(object sender, EventArgs e)
    {
        if (!Roles.RoleExists(TextBoxNewRuolo.Text))
        {
            Roles.CreateRole(TextBoxNewRuolo.Text);
            ListBoxRuoli.Items.Add(TextBoxNewRuolo.Text);
            CheckBoxListRuoli.Items.Add(TextBoxNewRuolo.Text);
        }
        else
            LabelMsg.Text= "Ruolo " + TextBoxNewRuolo.Text + " gi esistente";
    }
    protected void ButtonDelete_Click(object sender, EventArgs e)
    {
        for (int i = 0; i < CheckBoxListRuoli.Items.Count; i++)
            if (CheckBoxListRuoli.Items[i].Selected)
            {
                Roles.RemoveUsersFromRole(Roles.GetUsersInRole(CheckBoxListRuoli.Items[i].Text), CheckBoxListRuoli.Items[i].Text);
                Roles.DeleteRole(CheckBoxListRuoli.Items[i].Text);
            }
        PopolamentoListeRuoli();
        PopolamentoListeUtenti();
    }
    protected void PopolamentoListeRuoli()
    {
        string[] ruoli;
        ruoli = Roles.GetAllRoles();
        ListBoxRuoli.Items.Clear();
        CheckBoxListRuoli.Items.Clear();
        for (int i = 0; i < ruoli.Length; i++)
        {
            ListBoxRuoli.Items.Add(ruoli[i].ToString());
            CheckBoxListRuoli.Items.Add(ruoli[i].ToString());
        }
    }
    protected void PopolamentoListeUtenti()
    {
        ListBoxUtenti.Items.Clear();
        if (ListBoxRuoli.SelectedItem != null)
        {
            string[] utentiInRuolo = Roles.GetUsersInRole(ListBoxRuoli.SelectedItem.ToString());
            for (int i = 0; i < utentiInRuolo.Length; i++)
                ListBoxUtenti.Items.Add(utentiInRuolo[i].ToString());
            // popolamento lista ListBoxUtentiNon
            ListBoxUtentiNon.Items.Clear();
            MembershipUserCollection utenti = Membership.GetAllUsers();
            foreach (MembershipUser UserName in utenti)
                if (!Roles.IsUserInRole(UserName.ToString(), ListBoxRuoli.SelectedItem.ToString()))
                    ListBoxUtentiNon.Items.Add(UserName.ToString());
        }
    }
}
